﻿Imports System.Console

Module Module1
    Dim lottó(52, 5) As Integer
    Dim hét As Integer
    Dim darab(90) As Integer
    Dim holvan As String = My.Application.Info.DirectoryPath

    Sub Main()
        WriteLine("A 2005. májusi emelt szintű érettségi feladat megoldása")
        WriteLine()

        Feladat1()
        Feladat2()
        Feladat3()
        Feladat4()
        Feladat5()
        Feladat6()
        feladat7()
        feladat8()
        Feladat9()

        ReadLine()
    End Sub

    Sub Feladat1()
        'Az 52. hét számainak beolvasása
        WriteLine("Kérem egyenként az 52. hét számait!")
        For i As Integer = 1 To 5
            Write(i & ". szám=")
            lottó(52, i) = ReadLine()
        Next
        WriteLine()
    End Sub

    Sub Feladat2()
        'A számok rendezése egyszerű cserével
        For i As Integer = 1 To 5
            For j As Integer = 1 To 5 - i
                If lottó(52, j) > lottó(52, j + 1) Then
                    Dim b As Integer = lottó(52, j)
                    lottó(52, j) = lottó(52, j + 1)
                    lottó(52, j + 1) = b
                End If
            Next
        Next

        WriteLine("Növekvő sorban:")
        For i As Integer = 1 To 5
            Write(lottó(52, i) & " ")
        Next
        WriteLine()
    End Sub

    Sub Feladat3()
        Dim fájl As IO.FileStream
        Dim olvasó As IO.StreamReader
        Dim str(5) As String
        Dim egysor As String

        'A lottószámok beolvasása a fájlból
        fájl = New IO.FileStream(holvan & "\..\..\lottosz.dat", IO.FileMode.Open)
        olvasó = New IO.StreamReader(fájl)
        For i As Integer = 1 To 51
            egysor = olvasó.ReadLine
            str = egysor.Split(" ")
            For j As Integer = 0 To 4
                lottó(i, j + 1) = Val(str(j))
            Next
        Next
        olvasó.Close()
        fájl.Close()

        'Egy adott hét sorszámának beolvasása
        WriteLine()
        Write("Adjon meg egy számot 1 és 51 között!=")
        hét = ReadLine()
    End Sub

    Sub Feladat4()
        Write("Az adott hét számai: ")
        For i As Integer = 1 To 5
            Write(lottó(hét, i) & " ")
        Next
        WriteLine()
    End Sub

    Sub Feladat5()
        Dim i As Integer
        Dim vane As Boolean

        'A gyakoriság meghatásrozása (az elemek megszámlálása)
        For i = 1 To 51
            For j As Integer = 1 To 5
                darab(lottó(i, j)) += 1
            Next
        Next

        'Volt-e 0 gyakoriságú, lineáris kereséssel
        i = 0
        vane = False
        Do While (i < 90 And vane = False)
            i += 1
            If darab(i) = 0 Then
                vane = True
            End If
        Loop
        WriteLine()
        If vane = True Then
            WriteLine("Van 0 gyakoriságú lottószám.")
        Else
            WriteLine("Nincs 0 gyakoriságú lottószám.")
        End If
        WriteLine()
    End Sub

    Sub Feladat6()
        'Hányszor volt páratlan, megszámlálás
        Dim s As Integer = 0
        For i As Integer = 1 To 51
            For j As Integer = 1 To 5
                If (lottó(i, j) Mod 2) = 1 Then
                    s += 1
                End If
            Next
        Next
        WriteLine("A páratlan számok száma= " & s)
        WriteLine()
    End Sub

    Sub Feladat7()
        Dim fájl As IO.FileStream
        Dim író As IO.StreamWriter
        'Az új fájl előállítása
        fájl = New IO.FileStream(holvan & "\..\..\lotto52.ki", IO.FileMode.Create)
        író = New IO.StreamWriter(fájl)
        For i As Integer = 1 To 52
            For j As Integer = 1 To 5
                író.Write(lottó(i, j))
                író.Write(" ")
            Next
            író.WriteLine()
        Next
        író.Close()
        fájl.Close()
    End Sub

    Sub Feladat8()
        'A gyakorságok bővítése az 52. hét adataival
        For j As Integer = 1 To 5
            darab(lottó(52, j)) += 1
        Next

        WriteLine("Az egyes számok gyakorisága:")
        For i As Integer = 1 To 90
            Write(darab(i) & " ")
            If i Mod 15 = 0 Then
                WriteLine()
            End If
        Next
        WriteLine()
    End Sub

    Sub Feladat9()
        Write("A nem kihúzott prímek: ")

        For n As Integer = 2 To 90
            'Prímszám-e az adott szám?, osztó keresése
            Dim l As Boolean = False
            Dim i As Integer = 1
            Do While i <= Math.Sqrt(n) And l = False
                i += 1
                If n Mod i = 0 Then
                    l = True
                End If
            Loop

            'Ha igen, és nem húzták ki, akkor kiírjuk
            If l = False Then
                If darab(n) = 0 Then
                    Write(n & " ")
                End If
            End If
        Next
    End Sub

End Module
